# Makefile for Alib under Win32

.SUFFIXES: .c

!include ..\config
!include ..\makerules.sc


# two additional packages not used in Shaman
# I want to remove them someday
#ADDINC = amem.h amsg.h
#ADDOBJ = message.obj tvmess.obj alert.obj error.obj log.obj log_low.obj \
#         ask.obj amem.obj

EXP1 = file_init file_term file_thread_init file_thread_term file_open \
       file_create file_close file_read file_write file_seek file_map
EXP2 = file_remap file_unmap file_chsize file_stat file_stat_by_handle \
       file_size file_size_by_handle file_delete file_rename file_exists \
       file_lock file_unlock

EXP3 = fs_mkdir fs_rmdir fs_mkdirhier fs_dir_exists \
       fs_chdir fs_curdir fs_disktotal fs_diskfree fn_split fn_basedir \
       fn_basename fn_getname fn_getext fn_chext fn_apply_path fn_fullname \
       fn_find fn_find_free

EXP4 = alib_init alib_thread_init alib_thread_term \
       opt_start opt_get

EXP5 = astr_init astr_term astr_tok astr_dequote astr_trans astr_ncpy \
       astr_ncat astr_get_str astr_get_value astr_itoa

EXP6 = astr_add_charset astr_get_charset astr_set_charset astr_encode \
       astr_decode astr_recode astr_nencode astr_ndecode astr_nrecode \
       is_upper is_lower to_upper to_lower astr_upper astr_lower astr_istr \
       astr_icmp

EXP7 = sys_pagesize dl_open dl_close dl_sym dl_recog

EXP8 = th_create th_exit th_join th_equal th_self th_key_create \
       th_key_delete th_setspecific th_getspecific mutex_create mutex_lock \
       mutex_trylock mutex_unlock mutex_destroy cond_create cond_signal \
       cond_wait cond_timedwait cond_destroy

EXP9 = time_init time_term time_gettimezone time_settimezone time_unpack \
       time_pack time_valid time_dayofweek time_now time_msleep \
       uls_init uls_term uls_inited uls_get

ALIBOBJ = AFILE.obj ASTR.obj acs.obj uls.obj AFS.obj ATIME.obj AFNAME.obj \
          aglob.obj aopt.obj alib.obj

all : objects objs

objects : $(ALIBOBJ)
        cd win32
        $(MAKE) objects INCLUDEPATH=$(INCLUDEPATH) ODIR=$(ODIR)
        cd ..
        for %f in ( $(ALIBOBJ) ) do copy %f $(ODIR)
        del explist
        for %i in ( $(EXP1) ) do echo EXPORTS %i >> explist
        for %i in ( $(EXP2) ) do echo EXPORTS %i >> explist
        for %i in ( $(EXP3) ) do echo EXPORTS %i >> explist
        for %i in ( $(EXP4) ) do echo EXPORTS %i >> explist
        for %i in ( $(EXP5) ) do echo EXPORTS %i >> explist
        for %i in ( $(EXP6) ) do echo EXPORTS %i >> explist
        for %i in ( $(EXP7) ) do echo EXPORTS %i >> explist
        for %i in ( $(EXP8) ) do echo EXPORTS %i >> explist
        for %i in ( $(EXP9) ) do echo EXPORTS %i >> explist

objs :
        cd win32
        $(MAKE) objs INCLUDEPATH=$(INCLUDEPATH) LIBDIR=$(LIBDIR)
        cd ..

clean :
  cd win32
  $(MAKE) clean
  cd ..
  del *.obj
  del *.exe
  del *.map
  del *.crf
  del *.me
  del *.tmp
  del explist
  del _depend
  del *.dll

distclean : clean
  cd win32
  $(MAKE) distclean
  cd ..
  move makefile makefile.sc

dep depend :
  cd win32
  $(MAKE) dep INCLUDEPATH=$(INCLUDEPATH)
  cd ..
  command /C makedep -s -i$(INCLUDEPATH) *.c > _depend


