!include config
!include makerules.sc

LIBSUBDIRS = alib support language shdll # vbase
SUBDIRS = $(LIBSUBDIRS) test # doc

all: libs tests

objs: 
        del lib\*.obj
        cd alib
        $(MAKE) objs
        cd ..

conf :
        for %i in ( $(SUBDIRS) alib\win32 ) do $(MAKE) premake SUBDIR=%i

premake :
	cd $(SUBDIR)
	if not exist makefile copy makefile.sc makefile
	cd ..

do_subdir :
	cd $(SUBDIR)
        $(MAKE) $(TARGET)
	cd ..

objects :
	del obj\*.obj
	for %i in ( $(LIBSUBDIRS) ) do $(MAKE) do_subdir SUBDIR=%i TARGET=objects

libs : objects objs
	cd obj
	for %f in ( *.obj ) do echo +%f& >> liblist
        $(AR) /c /n shaman.lib @liblist
	move shaman.lib ..\lib
	del liblist
	cd ..
        echo EXETYPE NT >  obj\shaman.def
        echo LIBRARY shaman   >> obj\shaman.def
        for %i in ( $(LIBSUBDIRS) ) do type %i\explist >> obj\shaman.def
        cd obj
	echo $(LIBDIR)\dll_main.obj > objlist
	echo $(TOPDIR)\shdll\shaman.obj >> objlist
	for %i in ( *.obj ) do echo %i >> objlist
        $(CC) -o shaman.dll -L/implib:shimp.lib/nomap $(SHLFLAGS) \
              shaman.def kernel32.lib @objlist
	move shaman.dll ..\lib
	move shimp.lib ..\lib
	del objlist
        del shaman.def
        del shaman.map # link seems to create it in any case
	cd ..

install :
        copy lib\*.lib $(INSTLIBDIR)
        copy include\*.h $(INSTINCDIR)
        copy lib\*.dll $(INSTDLLDIR)
        copy lib\*.obj $(INSTLIBDIR)

          

tests: libs
	cd test
        $(MAKE) all
        $(MAKE) run
	cd ..

clean mostlyclean realclean :
        for %i in ( $(SUBDIRS) ) do $(MAKE) do_subdir SUBDIR=%i TARGET=$@
	del lib\*.lib
        del lib\*.obj
        del lib\*.dll
        del lib\*.def
        del lib\objlist
        del lib\liblist
	del obj\*.obj
	

distclean : clean
        for %i in ( $(SUBDIRS) ) do $(MAKE) do_subdir SUBDIR=%i TARGET=$@
	move makefile makefile.sc
	del include\shnana.h
        del config

dep depend:
        for %i in ( $(SUBDIRS) ) do $(MAKE) do_subdir SUBDIR=%i TARGET=$@

# Need to have privileges to write to a directory one step upper
dist distr:	distclean
	cd ..
	tar zcvvf $(SHAMNAME).tar.gz $(SHAMNAME)
	move $(SHAMNAME).tar.gz $(SHAMNAME)
	cd $(SHDIR)

zdistr: distclean
	cd ..
	del $(SHAMNAME).zip
	zip -r $(SHAMNAME).zip $(SHAMNAME)
	move $(SHAMNAME).zip $(SHAMNAME)
  	echo $(SHDIR)
	cd $(SHDIR)
