.SUFFIXES: .c

include ..\config
include ..\makerules.sc

LIBS = printfn.obj $(LIBDIR)\shimp.lib

DMAIN = $(LIBDIR)\dll_main.obj

LFLAGS = printfn.obj $(SHLIBFLAGS) $(LIBFLAGS)
#LFLAGS = $(STATICFLAGS) $(LIBFLAGS)
EFLAGS = $(CFLAGS) $(EXEFLAGS) -o $@
DFLAGS = -o $@ $(SHLFLAGS) $(DMAIN)

all: filetest.exe fntest.exe globtest.exe timetest.exe strtest.exe \
     ulstest.exe systest.exe dll.dll \
     resource.exe dl-h.exe fileres.exe l-native.exe cache.exe lp-cache.exe \
     f-native.dll fun.dll

filetest.exe : filetest.obj $(LIBS)
        $(CC) $(EFLAGS) filetest.obj $(LFLAGS)

fntest.exe : fntest.obj $(LIBS)
        $(CC) $(EFLAGS) fntest.obj $(LFLAGS)

globtest.exe : globtest.obj $(LIBS)
        $(CC) $(EFLAGS) globtest.obj $(LFLAGS)

timetest.exe : timetest.obj $(LIBS)
        $(CC) $(EFLAGS) timetest.obj $(LFLAGS)

strtest.exe : strtest.obj $(LIBS)
        $(CC) $(EFLAGS) strtest.obj $(LFLAGS)

ulstest.exe : ulstest.obj $(LIBS)
        $(CC) $(EFLAGS) ulstest.obj $(LFLAGS)

systest.exe : systest.obj $(LIBS)
        $(CC) $(EFLAGS) systest.obj $(LFLAGS)


resource.exe: resource.obj $(LIBS)
        $(CC) $(EFLAGS) resource.obj $(LFLAGS)

dl-h.exe: dl-h.obj $(LIBS)
        $(CC) $(EFLAGS) dl-h.obj $(LFLAGS)

fileres.exe: fileres.obj $(LIBS)
        $(CC) $(EFLAGS) fileres.obj $(LFLAGS)

l-native.exe: l-native.obj $(LIBS)
        $(CC) $(EFLAGS) l-native.obj $(LFLAGS)

cache.exe: cache.obj $(LIBS)
        $(CC) $(EFLAGS) cache.obj $(LFLAGS)

lp-cache.exe: lp-cache.obj $(LIBS)
        $(CC) $(EFLAGS) lp-cache.obj $(LFLAGS)

dll.dll : dll.obj
        $(CC) $(DFLAGS) dll.obj dll_sc.def $(LFLAGS) kernel32.lib

fun.dll : fun.obj
        $(CC) $(DFLAGS) fun.obj fun_sc.def $(LFLAGS) kernel32.lib

f-native.dll : f-native.obj
        $(CC) $(DFLAGS) f-native.obj f-nat_sc.def $(LFLAGS) kernel32.lib

run check: copy_dll run-resource run-dl-h run-fileres run-lang-native \
           run-cache run-lp-cache

copy_dll copy-dll :
        copy $(LIBDIR)\shaman.dll .

run-resource: resource.exe resource.exp
	resource > resource.out
	fc resource.out resource.exp

run-dl-h: dl-h.exe fun.dll dl-h.exp
	dl-h > dl-h.out
	fc dl-h.out dl-h.exp

run-fileres: fileres.exe fileres.exp
	fileres > fileres.out
	fc fileres.out fileres.exp

run-lang-native: l-native.exe f-native.dll l-native.exp
	l-native > l-native.out
	fc l-native.out l-native.exp

run-cache: cache.exe cache.exp
	cache > cache.out
	fc cache.out cache.exp

run-lp-cache: lp-cache.exe f-native.dll lp-cache.exp
	lp-cache > lp-cache.out
	fc lp-cache.out lp-cache.exp

dep depend:
	command /c makedep -s -i$(INCLUDEPATH) *.c > _depend

clean mostlyclean:
        del *.obj
        del *.out
	del *.exe
	del *.so
	del *.map
	del *.dll
	del _depend

realclean distclean: clean
	move makefile makefile.sc
